searchData={"items":[{"type":"task","title":"mix mod.new","doc":"Creates a new module in the current application, based on a template.\n\nThe location of the new module is defined  according to the `:mount` option in\n`:modkit` configuration defined in the project file (`mix.exs`).\n\nIf not defined, default mount points are defined as follows:\n\n    [\n      {App, \"lib/app\"}\n      {Mix.Tasks, \"lib/mix/tasks\", flavor: :mix_task}\n    ]","ref":"Mix.Tasks.Mod.New.html"},{"type":"task","title":"Usage - mix mod.new","doc":"```shell\nmix mod.new [options]  \n```","ref":"Mix.Tasks.Mod.New.html#module-usage"},{"type":"task","title":"Options - mix mod.new","doc":"* `-g, --gen-server` - use GenServer and define base functions. Defaults to `false`.\n* `-s, --supervisor` - use Supervisor and define base functions. Defaults to `false`.\n* `-d, --dynamic-supervisor` - use DynamicSupervisor and define base functions. Defaults to `false`.\n* `-p, --path  ` - The path of the module to write. Unnecessary if the module prefix is mounted.\n* `-o, --overwrite` - Overwrite the file if it exists. Always prompt. Defaults to `false`.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Mod.New.html#module-options"},{"type":"task","title":"mix mod.relocate","doc":"Relocates modules in application according to the `:mount` option in `:modkit`\nconfiguration defined in the project file (`mix.exs`).\n\nIf not defined, default mount points are defined as follows:\n\n    [\n      {App, \"lib/app\"}\n      {Mix.Tasks, \"lib/mix/tasks\", flavor: :mix_task}\n    ]","ref":"Mix.Tasks.Mod.Relocate.html"},{"type":"task","title":"Usage - mix mod.relocate","doc":"```shell\nmix mod.relocate [options]\n```","ref":"Mix.Tasks.Mod.Relocate.html#module-usage"},{"type":"task","title":"Options - mix mod.relocate","doc":"* `-i, --interactive` - This flag will make the command prompt for confirmation whenever a file can be relocated. Takes precedences over `--force`. Defaults to `false`.\n* `-f, --force` - This flag will make the command actually relocate the files. Defaults to `false`.\n* `--help` - Displays this help.","ref":"Mix.Tasks.Mod.Relocate.html#module-options"},{"type":"module","title":"Modkit","doc":"","ref":"Modkit.html"},{"type":"function","title":"Modkit.load_current_project/0","doc":"","ref":"Modkit.html#load_current_project/0"},{"type":"module","title":"Modkit.CLI","doc":"","ref":"Modkit.CLI.html"},{"type":"function","title":"Modkit.CLI.color/2","doc":"Outputs `iodata` in the current shell, wrapped with formatting\ninformation, such as `[color, iodata, :default_color]`.\n\n`color` should be a `IO.ANSI.format/2` compatible atom.","ref":"Modkit.CLI.html#color/2"},{"type":"function","title":"Modkit.CLI.debug/1","doc":"Outputs `iodata` in the current shell, formatted with cyan color.","ref":"Modkit.CLI.html#debug/1"},{"type":"function","title":"Modkit.CLI.error/1","doc":"Outputs `iodata` to `stderr` in the current shell, formatted with bright\nred color.","ref":"Modkit.CLI.html#error/1"},{"type":"function","title":"Modkit.CLI.format_usage/2","doc":"Returns a standard \"usage\" documentation block describing the different\noptions of the given command.","ref":"Modkit.CLI.html#format_usage/2"},{"type":"function","title":"Options - Modkit.CLI.format_usage/2","doc":"* `:format` - If `:moduledoc`, the formatted usage will be compatible for\n  embedding in a `@moduledoc` attribute. Any other value will generate a\n  simple terminal styled text. Defaults to `:cli`.","ref":"Modkit.CLI.html#format_usage/2-options"},{"type":"function","title":"Modkit.CLI.halt/1","doc":"Stops the execution of the Erlang runtime, with a given return code.\n\nIf not provided, the return code will be `0`.","ref":"Modkit.CLI.html#halt/1"},{"type":"function","title":"Modkit.CLI.halt_error/2","doc":"Combines `error/1` then `halt/1`. Halts the Erlang runtime with a `1`\nreturn code by default.","ref":"Modkit.CLI.html#halt_error/2"},{"type":"function","title":"Modkit.CLI.halt_success/1","doc":"Combines `success/1` then `halt/1`. Halts the Erlang runtime with a `0`\nreturn code.","ref":"Modkit.CLI.html#halt_success/1"},{"type":"function","title":"Modkit.CLI.parse/2","doc":"Accepts the command line arguments and the definition of a command\n(options, arguments, and metadata) and returns a parse result with values\nextracted from the command line arguments.","ref":"Modkit.CLI.html#parse/2"},{"type":"function","title":"Defining options - Modkit.CLI.parse/2","doc":"Options definitions is a `Keyword` whose keys are the option name, and\nvalues are the options parameters. Note that keys with underscores like\n`some_thing` define options in kebab case like `--some-thing`.\n\nThe following parameters are available:\n\n- `:type` - Can be either `:boolean`, `:integer` or `:string`. The default\n  value is `:string`.\n- `:short` - Defines the shortcut for the option, for instance `-p`\n  instead of `--port`.\n- `:default` - Defines the default value if the corresponding option is\n  not defined in `argv`.See \"Default values\" below.\n- `:doc` - Accepts a string that will be used when formatting the usage\n  block for the command.\n\nNote that the `:help` option is always defined and cannot be overridden.","ref":"Modkit.CLI.html#parse/2-defining-options"},{"type":"function","title":"Default values - Modkit.CLI.parse/2","doc":"Default values can be omitted, in that case, the option will not be\npresent at all if not provided in the command line.\n\nWhen defined, a default value can be:\n\n* A raw value, that is anything that is not a function. This value will be\n  used as the default value.\n* A function of arity zero. This function will be called when the option\n  is not provided in the command line and the result value will be used as\n  the default value. For instance `fn -> 123 end` or `&default_age/0`.\n* A function of arity one. This function will be called with the option\n  key as its argument. For instance, passing `&default_opt/1` as the\n  `:default` for an option definition allow to define the following\n  function:\n\n      defp default_opt(:port), do: 4000\n      defp default_opt(:scheme), do: \"http\"","ref":"Modkit.CLI.html#parse/2-default-values"},{"type":"function","title":"Options examples - Modkit.CLI.parse/2","doc":"iex> {:ok, result} = parse(~w(--who joe), [options: [who: [type: :string]]])\n    iex> result.options.who\n    \"joe\"\n\n    iex> {:ok, result} = parse(~w(--who joe), [options: [who: []]])\n    iex> result.options.who\n    \"joe\"\n\n    iex> {:ok, result} = parse(~w(--port 4000), [options: [port: [type: :integer]]])\n    iex> result.options.port\n    4000\n\n    iex> {:ok, result} = parse(~w(-p 4000), [options: [port: [type: :integer, short: :p]]])\n    iex> result.options.port\n    4000\n\n    iex> parse(~w(--port nope), [options: [port: [type: :integer]]])\n    {:error, {:invalid, [{\"--port\", \"nope\"}]}}\n\n    iex> {:ok, result} = parse([], [options: [lang: [default: \"elixir\"]]])\n    iex> result.options.lang\n    \"elixir\"\n\n    iex> {:ok, result} = parse([], [options: [lang: []]])\n    iex> Map.has_key?(result.options, :lang)\n    false\n\n    iex> {:ok, result} = parse([], options: [])\n    iex> result.options.help\n    false\n\n    iex> {:ok, result} = parse(~w(--help), options: [])\n    iex> result.options.help\n    true","ref":"Modkit.CLI.html#parse/2-options-examples"},{"type":"function","title":"Defining arguments - Modkit.CLI.parse/2","doc":"Arguments can be defined in the same way, providing a `Keyword` where the\nkeys are the argument names and the values are the parameters.","ref":"Modkit.CLI.html#parse/2-defining-arguments"},{"type":"function","title":"Defining arguments - Modkit.CLI.parse/2","doc":"The following parameters are available:\n\n- `:required` - A boolean marking the argument as required. **Note that\n  arguments are required by default**. Keys for optional arguments that\n  are not provided by the command line will not be defined in the results.\n- `:cast` - Accepts a fun or a `{module, function, arguments}` tuple to\n  transform the argument value when parsing. The invoked function must\n  return a result tuple: `{:ok, _} | {:error, _}`.\n- `:doc` - Accepts a string that will be used when formatting the usage\n  block for the command. Note that this is not currently implemented for\n  arguments.","ref":"Modkit.CLI.html#parse/2-defining-arguments"},{"type":"function","title":"Arguments examples - Modkit.CLI.parse/2","doc":"iex> {:ok, result} = parse(~w(joe), arguments: [who: []])\n    iex> result.arguments.who\n    \"joe\"\n\n    iex> parse([], arguments: [who: []])\n    {:error, {:missing_argument, :who}}\n\n    iex> {:ok, result} = parse([], arguments: [who: [required: false]])\n    iex> result.arguments\n    %{}\n\n    iex> cast = fn string -> Date.from_iso8601(string) end\n    iex> {:ok, result} = parse([\"2022-12-22\"], arguments: [date: [cast: cast]])\n    iex> result.arguments.date\n    ~D[2022-12-22]\n\n    iex> cast = {Date, :from_iso8601, []}\n    iex> {:ok, result} = parse([\"2022-12-22\"], arguments: [date: [cast: cast]])\n    iex> result.arguments.date\n    ~D[2022-12-22]\n\n    iex> cast = {Date, :from_iso8601, []}\n    iex> parse([\"not-a-date\"], arguments: [date: [cast: cast]])\n    {:error, {:argument_cast, :date, :invalid_format}}","ref":"Modkit.CLI.html#parse/2-arguments-examples"},{"type":"function","title":"Modkit.CLI.parse_or_halt!/2","doc":"Attempts to parse the command line arguments `argv` with the defined\ncommand.\n\nCommand options and arguments are documented in the `parse/2` function of\nthis module.\n\nIn `parse_or_halt!/2`, the successful return value will not be wrapped in\nan `:ok` tuple, but directly a map with the `:options` and `:arguments`\nkeys.\n\nIn case of a parse error, this function will output the usage block\nfollowed by a formatted error message, and halt the Erlang runtime.","ref":"Modkit.CLI.html#parse_or_halt!/2"},{"type":"function","title":"Modkit.CLI.put_shell/1","doc":"Defines the current shell to send console messages to. Accepts either\n`Modkit.CLI` or `Modkit.CLI.ProcessShell`.\n\nThe shell is saved to `:persistent_term`, so shell should not be changed\nrepeatedly during runtime. This method of persistence is subject to change\nand should not be relied on.","ref":"Modkit.CLI.html#put_shell/1"},{"type":"function","title":"Modkit.CLI.shell/0","doc":"Returns the current shell used by Modkit.CLI to send output.","ref":"Modkit.CLI.html#shell/0"},{"type":"function","title":"Modkit.CLI.success/1","doc":"Outputs `iodata` in the current shell, formatted with green color.","ref":"Modkit.CLI.html#success/1"},{"type":"function","title":"Modkit.CLI.warn/1","doc":"Outputs `iodata` to `stderr` in the current shell, formatted with yellow\ncolor.","ref":"Modkit.CLI.html#warn/1"},{"type":"function","title":"Modkit.CLI.writeln/1","doc":"Outputs `iodata` in the current shell.","ref":"Modkit.CLI.html#writeln/1"},{"type":"module","title":"Modkit.CLI.ProcessShell","doc":"An output shell implementation allowing your CLI commands to send their\noutput as messages to themselves. This is most useful for tests.\n\nThe process that will receive the messages is found by looking up the\nfirst pid in the `:\"$callers\"` key of the process dictionary, or\n`self()` if there is no caller.\n\nUse `Modkit.CLI.put_shell(Modkit.CLI.ProcessShell)` to enable this\nshell.","ref":"Modkit.CLI.ProcessShell.html"},{"type":"function","title":"Modkit.CLI.ProcessShell.message_target/0","doc":"Returns the pid of the process that will receive output messages.","ref":"Modkit.CLI.ProcessShell.html#message_target/0"},{"type":"module","title":"Modkit.Mod","doc":"","ref":"Modkit.Mod.html"},{"type":"function","title":"Modkit.Mod.current_path/2","doc":"","ref":"Modkit.Mod.html#current_path/2"},{"type":"function","title":"Modkit.Mod.list_all/1","doc":"","ref":"Modkit.Mod.html#list_all/1"},{"type":"function","title":"Modkit.Mod.list_by_file/2","doc":"","ref":"Modkit.Mod.html#list_by_file/2"},{"type":"function","title":"Modkit.Mod.local_root/1","doc":"Returns the module that is a local root of all given modules. That is a common\nprefix of all given modules that is also a module from the list.\n\nFor instance, modules `A` and `A.B` have a common prefix that is `A`, and `A`\nis provided as an argument, so it will be returned.\n\nBut if only `A.B` and `A.C` are provided, the common prefix `A` will not be\nreturned since it is not one of the arguments.","ref":"Modkit.Mod.html#local_root/1"},{"type":"function","title":"Examples - Modkit.Mod.local_root/1","doc":"iex> local_root([A, A.B])\n    A\n\n    iex> local_root([A.B, A.C, A])\n    A\n\n    iex> local_root([A.B, A.C])\n    nil\n\n    iex> local_root([])\n    nil","ref":"Modkit.Mod.html#local_root/1-examples"},{"type":"function","title":"Modkit.Mod.local_root/2","doc":"Given two module names, returns the module name that is a prefix of the other,\nor `nil` if the two names are disjoint.\n\nSee `local_root/1`.","ref":"Modkit.Mod.html#local_root/2"},{"type":"function","title":"Examples - Modkit.Mod.local_root/2","doc":"iex> local_root(A, A.B)\n    A\n\n    iex> local_root(A.B, A.C)\n    nil","ref":"Modkit.Mod.html#local_root/2-examples"},{"type":"module","title":"Modkit.Mod.Template.BaseModule","doc":"","ref":"Modkit.Mod.Template.BaseModule.html"},{"type":"function","title":"Modkit.Mod.Template.BaseModule.template/0","doc":"","ref":"Modkit.Mod.Template.BaseModule.html#template/0"},{"type":"module","title":"Modkit.Mod.Template.DynamicSupervisorTemplate","doc":"","ref":"Modkit.Mod.Template.DynamicSupervisorTemplate.html"},{"type":"function","title":"Modkit.Mod.Template.DynamicSupervisorTemplate.template/0","doc":"","ref":"Modkit.Mod.Template.DynamicSupervisorTemplate.html#template/0"},{"type":"module","title":"Modkit.Mod.Template.GenServerTemplate","doc":"","ref":"Modkit.Mod.Template.GenServerTemplate.html"},{"type":"function","title":"Modkit.Mod.Template.GenServerTemplate.template/0","doc":"","ref":"Modkit.Mod.Template.GenServerTemplate.html#template/0"},{"type":"module","title":"Modkit.Mod.Template.MixTaskTemplate","doc":"","ref":"Modkit.Mod.Template.MixTaskTemplate.html"},{"type":"function","title":"Modkit.Mod.Template.MixTaskTemplate.template/0","doc":"","ref":"Modkit.Mod.Template.MixTaskTemplate.html#template/0"},{"type":"module","title":"Modkit.Mod.Template.SupervisorTemplate","doc":"","ref":"Modkit.Mod.Template.SupervisorTemplate.html"},{"type":"function","title":"Modkit.Mod.Template.SupervisorTemplate.template/0","doc":"","ref":"Modkit.Mod.Template.SupervisorTemplate.html#template/0"},{"type":"module","title":"Modkit.Mod.Template.UnitTestTemplate","doc":"","ref":"Modkit.Mod.Template.UnitTestTemplate.html"},{"type":"function","title":"Modkit.Mod.Template.UnitTestTemplate.template/0","doc":"","ref":"Modkit.Mod.Template.UnitTestTemplate.html#template/0"},{"type":"module","title":"Modkit.Mount","doc":"","ref":"Modkit.Mount.html"},{"type":"function","title":"Modkit.Mount.define/1","doc":"","ref":"Modkit.Mount.html#define/1"},{"type":"function","title":"Modkit.Mount.define!/1","doc":"","ref":"Modkit.Mount.html#define!/1"},{"type":"function","title":"Modkit.Mount.define_point/1","doc":"","ref":"Modkit.Mount.html#define_point/1"},{"type":"function","title":"Modkit.Mount.preferred_path/2","doc":"","ref":"Modkit.Mount.html#preferred_path/2"},{"type":"function","title":"Modkit.Mount.prefix_of?/2","doc":"","ref":"Modkit.Mount.html#prefix_of?/2"},{"type":"function","title":"Modkit.Mount.resolve/2","doc":"","ref":"Modkit.Mount.html#resolve/2"},{"type":"module","title":"Modkit.Mount.Point","doc":"","ref":"Modkit.Mount.Point.html"},{"type":"module","title":"Modkit.SnakeCase","doc":"","ref":"Modkit.SnakeCase.html"},{"type":"function","title":"Modkit.SnakeCase.to_snake/1","doc":"","ref":"Modkit.SnakeCase.html#to_snake/1"},{"type":"module","title":"Samplex.SingleSample","doc":"","ref":"Samplex.SingleSample.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}